package javax.swing.text;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;
import javax.swing.SwingUtilities;
import javax.swing.text.Position.Bias;

public class ComponentView extends View {
   private Component createdC;
   // $FF: renamed from: c java.awt.Component
   private Component field_0;

   public ComponentView(Element var1) {
      super(var1);
   }

   protected Component createComponent() {
      AttributeSet var1 = ((View)this).getElement().getAttributes();
      Component var2 = StyleConstants.getComponent(var1);
      return var2;
   }

   public final Component getComponent() {
      return this.createdC;
   }

   public void paint(Graphics var1, Shape var2) {
   }

   public float getPreferredSpan(int var1) {
      if (var1 != 0 && var1 != 1) {
         throw new IllegalArgumentException("Invalid axis: " + var1);
      } else if (this.field_0 != null) {
         Dimension var2 = this.field_0.getPreferredSize();
         return var1 == 0 ? (float)var2.width : (float)var2.height;
      } else {
         return 0.0F;
      }
   }

   public float getMinimumSpan(int var1) {
      if (var1 != 0 && var1 != 1) {
         throw new IllegalArgumentException("Invalid axis: " + var1);
      } else if (this.field_0 != null) {
         Dimension var2 = this.field_0.getMinimumSize();
         return var1 == 0 ? (float)var2.width : (float)var2.height;
      } else {
         return 0.0F;
      }
   }

   public float getMaximumSpan(int var1) {
      if (var1 != 0 && var1 != 1) {
         throw new IllegalArgumentException("Invalid axis: " + var1);
      } else if (this.field_0 != null) {
         Dimension var2 = this.field_0.getMaximumSize();
         return var1 == 0 ? (float)var2.width : (float)var2.height;
      } else {
         return 0.0F;
      }
   }

   public float getAlignment(int var1) {
      if (this.field_0 != null) {
         switch (var1) {
            case 0:
               return this.field_0.getAlignmentX();
            case 1:
               return this.field_0.getAlignmentY();
         }
      }

      return super.getAlignment(var1);
   }

   public void setSize(float var1, float var2) {
   }

   public void setParent(View var1) {
      super.setParent(var1);
      if (SwingUtilities.isEventDispatchThread()) {
         this.setComponentParent();
      } else {
         1 var2 = new 1(this);
         SwingUtilities.invokeLater(var2);
      }

   }

   void setComponentParent() {
      View var1 = ((View)this).getParent();
      if (var1 != null) {
         Container var2 = ((View)this).getContainer();
         if (var2 != null) {
            if (this.field_0 == null) {
               Component var3 = this.createComponent();
               if (var3 != null) {
                  this.createdC = var3;
                  this.field_0 = new Invalidator(this, var3);
               }
            }

            if (this.field_0 != null && this.field_0.getParent() == null) {
               var2.add(this.field_0, this);
            }
         }
      }

   }

   public Shape modelToView(int var1, Shape var2, Position.Bias var3) throws BadLocationException {
      int var4 = ((View)this).getStartOffset();
      int var5 = ((View)this).getEndOffset();
      if (var1 >= var4 && var1 <= var5) {
         Rectangle var6 = var2.getBounds();
         if (var1 == var5) {
            var6.x += var6.width;
         }

         var6.width = 0;
         return var6;
      } else {
         throw new BadLocationException(var1 + " not in range " + var4 + "," + var5, var1);
      }
   }

   public int viewToModel(float var1, float var2, Shape var3, Position.Bias[] var4) {
      Rectangle var5 = (Rectangle)var3;
      if (var1 < (float)(var5.x + var5.width / 2)) {
         var4[0] = Bias.Forward;
         return ((View)this).getStartOffset();
      } else {
         var4[0] = Bias.Backward;
         return ((View)this).getEndOffset();
      }
   }
}
