package javax.swing.text;

import java.text.CharacterIterator;

public class Segment implements Cloneable, CharacterIterator {
   public char[] array;
   public int offset;
   public int count;
   private int pos;

   public Segment() {
      this.array = null;
      this.offset = 0;
      this.count = 0;
   }

   public Segment(char[] var1, int var2, int var3) {
      this.array = var1;
      this.offset = var2;
      this.count = var3;
   }

   public String toString() {
      return this.array != null ? new String(this.array, this.offset, this.count) : new String();
   }

   public char first() {
      this.pos = this.offset;
      return this.count != 0 ? this.array[this.pos] : '\uffff';
   }

   public char last() {
      this.pos = this.offset + this.count;
      if (this.count != 0) {
         --this.pos;
         return this.array[this.pos];
      } else {
         return '\uffff';
      }
   }

   public char current() {
      return this.count != 0 ? this.array[this.pos] : '\uffff';
   }

   public char next() {
      ++this.pos;
      int var1 = this.offset + this.count;
      if (this.pos >= var1) {
         this.pos = var1;
         return '\uffff';
      } else {
         return this.current();
      }
   }

   public char previous() {
      if (this.pos == this.offset) {
         return '\uffff';
      } else {
         --this.pos;
         return this.current();
      }
   }

   public char setIndex(int var1) {
      int var2 = this.offset + this.count;
      if (var1 >= this.offset && var1 <= var2) {
         this.pos = var1;
         return this.pos != var2 && this.count != 0 ? this.array[this.pos] : '\uffff';
      } else {
         throw new IllegalArgumentException("bad position: " + var1);
      }
   }

   public int getBeginIndex() {
      return this.offset;
   }

   public int getEndIndex() {
      return this.offset + this.count;
   }

   public int getIndex() {
      return this.pos;
   }

   public Object clone() {
      Object var1;
      try {
         var1 = super.clone();
      } catch (CloneNotSupportedException var3) {
         var1 = null;
      }

      return var1;
   }
}
