package javax.swing.text.html;

import javax.swing.text.StyleConstants;
import javax.swing.text.View;

class CSS$LengthValue extends CSS.CssValue {
   boolean percentage;
   float span;

   float getValue() {
      return this.getValue(0.0F);
   }

   float getValue(float var1) {
      return this.percentage ? this.span * var1 : this.span;
   }

   boolean isPercentage() {
      return this.percentage;
   }

   Object parseCssValue(String var1) {
      CSS$LengthValue var2;
      try {
         float var3 = Float.valueOf(var1);
         var2 = new CSS$LengthValue();
         var2.span = var3;
      } catch (NumberFormatException var5) {
         CSS.LengthUnit var4 = new CSS.LengthUnit(var1, (short)10, 0.0F);
         switch (var4.type) {
            case 0:
               var2 = new CSS$LengthValue();
               var2.span = Math.max(0.0F, var4.value);
               break;
            case 1:
               var2 = new CSS$LengthValue();
               var2.span = Math.max(0.0F, Math.min(1.0F, var4.value));
               var2.percentage = true;
               break;
            default:
               return null;
         }
      }

      var2.svalue = var1;
      return var2;
   }

   Object parseHtmlValue(String var1) {
      if (var1.equals("#DEFAULT")) {
         var1 = "1";
      }

      return this.parseCssValue(var1);
   }

   Object fromStyleConstants(StyleConstants var1, Object var2) {
      CSS$LengthValue var3 = new CSS$LengthValue();
      var3.svalue = var2.toString();
      var3.span = (Float)var2;
      return var3;
   }

   Object toStyleConstants(StyleConstants var1, View var2) {
      return new Float(this.getValue());
   }
}
