package javax.swing.text.html;

import java.awt.Component;
import java.awt.Font;
import javax.swing.JComponent;
import javax.swing.JTextArea;
import javax.swing.border.Border;
import javax.swing.text.AttributeSet;
import javax.swing.text.ComponentView;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.JTextComponent;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyledDocument;
import javax.swing.text.View;
import javax.swing.text.html.HTML.Attribute;

class CommentView extends HiddenTagView {
   static final Border CBorder = new CommentBorder();
   static final int commentPadding = 3;
   static final int commentPaddingD = 9;

   CommentView(Element var1) {
      super(var1);
   }

   protected Component createComponent() {
      JTextArea var1 = new JTextArea(this.getRepresentedText());
      Document var2 = ((View)this).getDocument();
      Font var3;
      if (var2 instanceof StyledDocument) {
         var3 = ((StyledDocument)var2).getFont(((View)this).getAttributes());
         var1.setFont(var3);
      } else {
         var3 = ((Component)var1).getFont();
      }

      ((HiddenTagView)this).updateYAlign(var3);
      ((JComponent)var1).setBorder(CBorder);
      ((JTextComponent)var1).getDocument().addDocumentListener(this);
      return var1;
   }

   void resetBorder() {
   }

   void _updateModelFromText() {
      JTextComponent var1 = this.getTextComponent();
      Document var2 = ((View)this).getDocument();
      if (var1 != null && var2 != null) {
         String var3 = var1.getText();
         SimpleAttributeSet var4 = new SimpleAttributeSet();
         super.isSettingAttributes = true;

         try {
            var4.addAttribute(Attribute.COMMENT, var3);
            ((StyledDocument)var2).setCharacterAttributes(((View)this).getStartOffset(), ((View)this).getEndOffset() - ((View)this).getStartOffset(), var4, false);
         } finally {
            super.isSettingAttributes = false;
         }
      }

   }

   JTextComponent getTextComponent() {
      return (JTextComponent)((ComponentView)this).getComponent();
   }

   String getRepresentedText() {
      AttributeSet var1 = ((View)this).getElement().getAttributes();
      if (var1 != null) {
         Object var2 = var1.getAttribute(Attribute.COMMENT);
         if (var2 instanceof String) {
            return (String)var2;
         }
      }

      return "";
   }
}
