package javax.swing.text.html;

import javax.swing.text.BoxView;
import javax.swing.text.ComponentView;
import javax.swing.text.Element;
import javax.swing.text.IconView;
import javax.swing.text.LabelView;
import javax.swing.text.StyleConstants;
import javax.swing.text.View;
import javax.swing.text.ViewFactory;
import javax.swing.text.html.CSS.Attribute;
import javax.swing.text.html.HTML.Tag;

public class HTMLEditorKit$HTMLFactory implements ViewFactory {
   public View create(Element var1) {
      Object var2 = var1.getAttributes().getAttribute(StyleConstants.NameAttribute);
      if (var2 instanceof HTML.Tag) {
         HTML.Tag var3 = (HTML.Tag)var2;
         if (var3 == Tag.CONTENT) {
            return new InlineView(var1);
         }

         if (var3 == Tag.IMPLIED) {
            String var4 = (String)var1.getAttributes().getAttribute(Attribute.WHITE_SPACE);
            if (var4 != null && var4.equals("pre")) {
               return new LineView(var1);
            }

            return new ParagraphView(var1);
         }

         if (var3 == Tag.P || var3 == Tag.H1 || var3 == Tag.H2 || var3 == Tag.H3 || var3 == Tag.H4 || var3 == Tag.H5 || var3 == Tag.H6 || var3 == Tag.DT) {
            return new ParagraphView(var1);
         }

         if (var3 == Tag.MENU || var3 == Tag.DIR || var3 == Tag.UL || var3 == Tag.OL) {
            return new ListView(var1);
         }

         if (var3 == Tag.BODY) {
            return new HTMLEditorKit.1(this, var1, 1);
         }

         if (var3 == Tag.HTML) {
            return new BlockView(var1, 1);
         }

         if (var3 == Tag.LI || var3 == Tag.CENTER || var3 == Tag.DL || var3 == Tag.DD || var3 == Tag.DIV || var3 == Tag.BLOCKQUOTE || var3 == Tag.PRE) {
            return new BlockView(var1, 1);
         }

         if (var3 == Tag.NOFRAMES) {
            return new NoFramesView(var1, 1);
         }

         if (var3 == Tag.IMG) {
            return new ImageView(var1);
         }

         if (var3 == Tag.ISINDEX) {
            return new IsindexView(var1);
         }

         if (var3 == Tag.HR) {
            return new HRuleView(var1);
         }

         if (var3 == Tag.BR) {
            return new BRView(var1);
         }

         if (var3 == Tag.TABLE) {
            return new TableView(var1);
         }

         if (var3 == Tag.INPUT || var3 == Tag.SELECT || var3 == Tag.TEXTAREA) {
            return new FormView(var1);
         }

         if (var3 == Tag.OBJECT) {
            return new ObjectView(var1);
         }

         if (var3 == Tag.FRAMESET) {
            if (var1.getAttributes().isDefined(javax.swing.text.html.HTML.Attribute.ROWS)) {
               return new FrameSetView(var1, 1);
            }

            if (var1.getAttributes().isDefined(javax.swing.text.html.HTML.Attribute.COLS)) {
               return new FrameSetView(var1, 0);
            }

            throw new Error("Can't build a" + var3 + ", " + var1 + ":" + "no ROWS or COLS defined.");
         }

         if (var3 == Tag.FRAME) {
            return new FrameView(var1);
         }

         if (var3 instanceof HTML.UnknownTag) {
            return new HiddenTagView(var1);
         }

         if (var3 == Tag.COMMENT) {
            return new CommentView(var1);
         }

         if (var3 == Tag.HEAD) {
            return new HTMLEditorKit.2(this, var1, 0);
         }

         if (var3 == Tag.TITLE || var3 == Tag.META || var3 == Tag.LINK || var3 == Tag.STYLE || var3 == Tag.SCRIPT || var3 == Tag.AREA || var3 == Tag.MAP || var3 == Tag.PARAM || var3 == Tag.APPLET) {
            return new HiddenTagView(var1);
         }
      }

      String var5 = var1.getName();
      if (var5 != null) {
         if (var5.equals("content")) {
            return new LabelView(var1);
         }

         if (var5.equals("paragraph")) {
            return new ParagraphView(var1);
         }

         if (var5.equals("section")) {
            return new BoxView(var1, 1);
         }

         if (var5.equals("component")) {
            return new ComponentView(var1);
         }

         if (var5.equals("icon")) {
            return new IconView(var1);
         }
      }

      return new LabelView(var1);
   }
}
