package javax.swing.text;

import java.util.Vector;
import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;

class StringContent$RemoveUndo extends AbstractUndoableEdit {
   protected int offset;
   protected int length;
   protected String string;
   protected Vector posRefs;
   // $FF: synthetic field
   private final StringContent this$0;

   protected StringContent$RemoveUndo(StringContent var1, int var2, String var3) {
      this.this$0 = var1;
      this.offset = var2;
      this.string = var3;
      this.length = var3.length();
      if (var1.marks != null) {
         this.posRefs = var1.getPositionsInRange((Vector)null, var2, this.length);
      }

   }

   public void undo() throws CannotUndoException {
      super.undo();

      try {
         StringContent var1 = this.this$0;
         synchronized(var1) {
            this.this$0.insertString(this.offset, this.string);
            if (this.posRefs != null) {
               this.this$0.updateUndoPositions(this.posRefs);
               this.posRefs = null;
            }

            this.string = null;
         }
      } catch (BadLocationException var4) {
         throw new CannotUndoException();
      }
   }

   public void redo() throws CannotRedoException {
      super.redo();

      try {
         StringContent var1 = this.this$0;
         synchronized(var1) {
            this.string = this.this$0.getString(this.offset, this.length);
            if (this.this$0.marks != null) {
               this.posRefs = this.this$0.getPositionsInRange((Vector)null, this.offset, this.length);
            }

            this.this$0.remove(this.offset, this.length);
         }
      } catch (BadLocationException var4) {
         throw new CannotRedoException();
      }
   }
}
