package javax.swing.text;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.EventListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

public class StyleContext$NamedStyle implements Style, Serializable {
   protected EventListenerList listenerList;
   protected transient ChangeEvent changeEvent;
   private transient AttributeSet attributes;
   // $FF: synthetic field
   static Class class$javax$swing$event$ChangeListener;
   // $FF: synthetic field
   private final StyleContext this$0;

   public StyleContext$NamedStyle(StyleContext var1, String var2, Style var3) {
      this.this$0 = var1;
      this.listenerList = new EventListenerList();
      this.changeEvent = null;
      this.attributes = var1.getEmptySet();
      if (var2 != null) {
         this.setName(var2);
      }

      if (var3 != null) {
         this.setResolveParent(var3);
      }

   }

   public StyleContext$NamedStyle(StyleContext var1, Style var2) {
      this(var1, (String)null, var2);
   }

   public StyleContext$NamedStyle(StyleContext var1) {
      this.this$0 = var1;
      this.listenerList = new EventListenerList();
      this.changeEvent = null;
      this.attributes = var1.getEmptySet();
   }

   public String toString() {
      return "NamedStyle:" + this.getName() + " " + this.attributes;
   }

   public String getName() {
      return this.isDefined(StyleConstants.NameAttribute) ? (String)this.getAttribute(StyleConstants.NameAttribute) : null;
   }

   public void setName(String var1) {
      if (var1 != null) {
         this.addAttribute(StyleConstants.NameAttribute, var1);
      }

   }

   public void addChangeListener(ChangeListener var1) {
      this.listenerList.add(class$javax$swing$event$ChangeListener == null ? (class$javax$swing$event$ChangeListener = class$("javax.swing.event.ChangeListener")) : class$javax$swing$event$ChangeListener, var1);
   }

   public void removeChangeListener(ChangeListener var1) {
      this.listenerList.remove(class$javax$swing$event$ChangeListener == null ? (class$javax$swing$event$ChangeListener = class$("javax.swing.event.ChangeListener")) : class$javax$swing$event$ChangeListener, var1);
   }

   protected void fireStateChanged() {
      Object[] var1 = this.listenerList.getListenerList();

      for(int var2 = var1.length - 2; var2 >= 0; var2 -= 2) {
         if (var1[var2] == (class$javax$swing$event$ChangeListener == null ? (class$javax$swing$event$ChangeListener = class$("javax.swing.event.ChangeListener")) : class$javax$swing$event$ChangeListener)) {
            if (this.changeEvent == null) {
               this.changeEvent = new ChangeEvent(this);
            }

            ((ChangeListener)var1[var2 + 1]).stateChanged(this.changeEvent);
         }
      }

   }

   public EventListener[] getListeners(Class var1) {
      return this.listenerList.getListeners(var1);
   }

   public int getAttributeCount() {
      return this.attributes.getAttributeCount();
   }

   public boolean isDefined(Object var1) {
      return this.attributes.isDefined(var1);
   }

   public boolean isEqual(AttributeSet var1) {
      return this.attributes.isEqual(var1);
   }

   public AttributeSet copyAttributes() {
      StyleContext$NamedStyle var1 = new StyleContext$NamedStyle(this.this$0);
      var1.attributes = this.attributes.copyAttributes();
      return var1;
   }

   public Object getAttribute(Object var1) {
      return this.attributes.getAttribute(var1);
   }

   public Enumeration getAttributeNames() {
      return this.attributes.getAttributeNames();
   }

   public boolean containsAttribute(Object var1, Object var2) {
      return this.attributes.containsAttribute(var1, var2);
   }

   public boolean containsAttributes(AttributeSet var1) {
      return this.attributes.containsAttributes(var1);
   }

   public AttributeSet getResolveParent() {
      return this.attributes.getResolveParent();
   }

   public void addAttribute(Object var1, Object var2) {
      StyleContext var3 = this.this$0;
      this.attributes = var3.addAttribute(this.attributes, var1, var2);
      this.fireStateChanged();
   }

   public void addAttributes(AttributeSet var1) {
      StyleContext var2 = this.this$0;
      this.attributes = var2.addAttributes(this.attributes, var1);
      this.fireStateChanged();
   }

   public void removeAttribute(Object var1) {
      StyleContext var2 = this.this$0;
      this.attributes = var2.removeAttribute(this.attributes, var1);
      this.fireStateChanged();
   }

   public void removeAttributes(Enumeration var1) {
      StyleContext var2 = this.this$0;
      this.attributes = var2.removeAttributes(this.attributes, var1);
      this.fireStateChanged();
   }

   public void removeAttributes(AttributeSet var1) {
      StyleContext var2 = this.this$0;
      if (var1 == this) {
         this.attributes = var2.getEmptySet();
      } else {
         this.attributes = var2.removeAttributes(this.attributes, var1);
      }

      this.fireStateChanged();
   }

   public void setResolveParent(AttributeSet var1) {
      if (var1 != null) {
         this.addAttribute(StyleConstants.ResolveAttribute, var1);
      } else {
         this.removeAttribute(StyleConstants.ResolveAttribute);
      }

   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      var1.defaultWriteObject();
      StyleContext.writeAttributeSet(var1, this.attributes);
   }

   private void readObject(ObjectInputStream var1) throws ClassNotFoundException, IOException {
      var1.defaultReadObject();
      this.attributes = SimpleAttributeSet.EMPTY;
      StyleContext.readAttributeSet(var1, this);
   }

   // $FF: synthetic method
   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError(((Throwable)var2).getMessage());
      }
   }
}
