package javax.swing.text;

import java.awt.Graphics;
import java.awt.Shape;
import javax.swing.event.DocumentEvent;

class ZoneView$Zone extends BoxView {
   Position start;
   Position end;
   int minorSpan;
   float volumeCoefficient;
   // $FF: synthetic field
   private final ZoneView this$0;

   ZoneView$Zone(ZoneView var1, Element var2, Position var3, Position var4) {
      super(var2, ((BoxView)var1).getAxis());
      this.this$0 = var1;
      this.minorSpan = 500;
      this.volumeCoefficient = 240.0F;
      this.start = var3;
      this.end = var4;
   }

   public void load() {
      if (!this.isLoaded()) {
         System.out.println("loading: " + this.getStartOffset() + "," + this.getEndOffset());
         Element var1 = ((View)this).getElement();
         ViewFactory var2 = ((View)this).getViewFactory();
         int var3 = var1.getElementIndex(this.getStartOffset());
         int var4 = var1.getElementIndex(this.getEndOffset());
         View[] var5 = new View[var4 - var3 + 1];

         for(int var6 = var3; var6 <= var4; ++var6) {
            var5[var6 - var3] = var2.create(var1.getElement(var6));
         }

         ((BoxView)this).replace(0, 0, var5);
      }

   }

   public void unload() {
      ((View)this).removeAll();
   }

   public boolean isLoaded() {
      return ((CompositeView)this).getViewCount() != 0;
   }

   protected void loadChildren(ViewFactory var1) {
   }

   protected int getViewIndexAtPosition(int var1) {
      Element var2 = ((View)this).getElement();
      int var3 = var2.getElementIndex(var1);
      int var4 = var2.getElementIndex(this.getStartOffset());
      return var3 - var4;
   }

   protected void layout(int var1, int var2) {
      if (this.isLoaded()) {
         super.layout(var1, var2);
      } else {
         int var3 = ((BoxView)this).getAxis();
         int var4 = var3 == 1 ? var1 : var2;
         if (var4 != this.minorSpan) {
            this.minorSpan = var4;
            ((BoxView)this).preferenceChanged((View)null, var3 == 0, var3 == 1);
         }
      }

   }

   protected boolean updateChildren(DocumentEvent.ElementChange var1, DocumentEvent var2, ViewFactory var3) {
      Element[] var4 = var1.getChildrenRemoved();
      Element[] var5 = var1.getChildrenAdded();
      Element var6 = ((View)this).getElement();
      int var7 = var6.getElementIndex(this.getStartOffset());
      int var8 = var6.getElementIndex(this.getEndOffset() - 1);
      int var9 = var1.getIndex();
      if (var9 >= var7 && var9 <= var8) {
         int var10 = var9 - var7;
         int var11 = Math.min(var8 - var7 + 1, var5.length);
         int var12 = Math.min(var8 - var7 + 1, var4.length);
         View[] var13 = new View[var11];

         for(int var14 = 0; var14 < var11; ++var14) {
            var13[var14] = var3.create(var5[var14]);
         }

         ((BoxView)this).replace(var10, var12, var13);
      }

      return true;
   }

   public AttributeSet getAttributes() {
      return this.this$0.getAttributes();
   }

   public float getPreferredSpan(int var1) {
      if (this.isLoaded()) {
         return super.getPreferredSpan(var1);
      } else if (((BoxView)this).getAxis() == var1) {
         int var2 = this.getEndOffset() - this.getStartOffset();
         float var3 = (float)var2 * this.volumeCoefficient;
         float var4 = var3 / (float)this.minorSpan;
         return var4;
      } else {
         return (float)this.minorSpan;
      }
   }

   public float getMinimumSpan(int var1) {
      if (this.isLoaded()) {
         return super.getMinimumSpan(var1);
      } else if (var1 == ((BoxView)this).getAxis()) {
         return this.getPreferredSpan(var1);
      } else {
         return var1 == 0 ? (float)(((CompositeView)this).getLeftInset() + ((CompositeView)this).getRightInset() + 1) : (float)(((CompositeView)this).getTopInset() + ((CompositeView)this).getBottomInset() + 1);
      }
   }

   public float getMaximumSpan(int var1) {
      if (this.isLoaded()) {
         return super.getMaximumSpan(var1);
      } else {
         return var1 == ((BoxView)this).getAxis() ? this.getPreferredSpan(var1) : 2147483.0F;
      }
   }

   public float getAlignment(int var1) {
      return this.isLoaded() ? super.getAlignment(var1) : 0.5F;
   }

   public void paint(Graphics var1, Shape var2) {
      this.load();
      super.paint(var1, var2);
   }

   public int viewToModel(float var1, float var2, Shape var3, Position.Bias[] var4) {
      this.load();
      return super.viewToModel(var1, var2, var3, var4);
   }

   public Shape modelToView(int var1, Shape var2, Position.Bias var3) throws BadLocationException {
      this.load();
      return super.modelToView(var1, var2, var3);
   }

   public int getStartOffset() {
      return this.start.getOffset();
   }

   public int getEndOffset() {
      return this.end.getOffset();
   }

   public void insertUpdate(DocumentEvent var1, Shape var2, ViewFactory var3) {
      if (this.isLoaded()) {
         super.insertUpdate(var1, var2, var3);
      }

   }

   public void removeUpdate(DocumentEvent var1, Shape var2, ViewFactory var3) {
      if (this.isLoaded()) {
         super.removeUpdate(var1, var2, var3);
      }

   }

   public void changedUpdate(DocumentEvent var1, Shape var2, ViewFactory var3) {
      if (this.isLoaded()) {
         super.changedUpdate(var1, var2, var3);
      }

   }
}
