package javax.swing.text.html;

import java.util.Enumeration;
import java.util.Vector;
import javax.swing.text.AttributeSet;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.View;
import javax.swing.text.html.HTML.Attribute;
import javax.swing.text.html.HTML.Tag;
import javax.swing.text.html.StyleSheet.SearchBuffer;

class StyleSheet$ViewAttributeSet extends StyleSheet.MuxingAttributeSet {
   View host;
   // $FF: synthetic field
   private final StyleSheet this$0;

   StyleSheet$ViewAttributeSet(StyleSheet var1, View var2) {
      this.this$0 = var1;
      this.host = var2;
      Document var3 = var2.getDocument();
      StyleSheet.SearchBuffer var4 = SearchBuffer.obtainSearchBuffer();
      Vector var5 = var4.getVector();

      try {
         if (var3 instanceof HTMLDocument) {
            StyleSheet var6 = var1;
            Element var7 = var2.getElement();
            AttributeSet var8 = var7.getAttributes();
            AttributeSet var9 = var1.translateHTMLToCSS(var8);
            if (var9.getAttributeCount() != 0) {
               var5.addElement(var9);
            }

            if (!var7.isLeaf()) {
               HTML.Tag var18 = (HTML.Tag)var8.getAttribute(StyleConstants.NameAttribute);
               Style var19 = var1.getRule(var18, var7);
               if (var19 != null) {
                  var5.addElement(var19);
               }
            } else {
               Enumeration var10 = var8.getAttributeNames();

               while(var10.hasMoreElements()) {
                  Object var11 = var10.nextElement();
                  if (var11 instanceof HTML.Tag) {
                     if ((HTML.Tag)var11 == Tag.A) {
                        Object var12 = var8.getAttribute((HTML.Tag)var11);
                        if (var12 != null && var12 instanceof AttributeSet) {
                           AttributeSet var13 = (AttributeSet)var12;
                           if (var13.getAttribute(Attribute.HREF) == null) {
                              continue;
                           }
                        }
                     }

                     Style var20 = var6.getRule((HTML.Tag)var11, var7);
                     if (var20 != null) {
                        var5.addElement(var20);
                     }
                  }
               }
            }
         }

         super.attrs = new AttributeSet[var5.size()];
         var5.copyInto(super.attrs);
      } finally {
         SearchBuffer.releaseSearchBuffer(var4);
      }

   }

   public boolean isDefined(Object var1) {
      if (var1 instanceof StyleConstants) {
         CSS.Attribute var2 = StyleSheet.access$000(this.this$0).styleConstantsKeyToCSSKey((StyleConstants)var1);
         if (var2 != null) {
            var1 = var2;
         }
      }

      return super.isDefined(var1);
   }

   public Object getAttribute(Object var1) {
      if (var1 instanceof StyleConstants) {
         CSS.Attribute var2 = StyleSheet.access$000(this.this$0).styleConstantsKeyToCSSKey((StyleConstants)var1);
         if (var2 != null) {
            Object var3 = this.doGetAttribute(var2);
            if (var3 instanceof CSS.CssValue) {
               return ((CSS.CssValue)var3).toStyleConstants((StyleConstants)var1, this.host);
            }
         }
      }

      return this.doGetAttribute(var1);
   }

   Object doGetAttribute(Object var1) {
      Object var2 = super.getAttribute(var1);
      if (var2 != null) {
         return var2;
      } else {
         if (var1 instanceof CSS.Attribute) {
            CSS.Attribute var3 = (CSS.Attribute)var1;
            if (var3.isInherited()) {
               AttributeSet var4 = this.getResolveParent();
               if (var4 != null) {
                  return var4.getAttribute(var1);
               }
            }
         }

         return null;
      }
   }

   public AttributeSet getResolveParent() {
      if (this.host == null) {
         return null;
      } else {
         View var1 = this.host.getParent();
         return var1 != null ? var1.getAttributes() : null;
      }
   }
}
